﻿var blueStatus = 0;
var switchBusy = false;
var theKeyDown = false;

function setup ( ) {
	if (window.widget) {

		updateStatus();
		widget.onshow = updateStatus;
		widget.onhide = doKeyUp;

		var openafterSaved = (widget.preferenceForKey(widget.identifier+"openafter")) ? widget.preferenceForKey(widget.identifier+"openafter") : "0";
		if (openafterSaved) openafter.options[openafterSaved].selected = true;		

	}
	theObject = document.getElementById('openafter');
	theObject.title = getLocalizedString('Click here to select an application that will open after Bluetooth is enabled. It will not open when you turn off Bluetooth.');
	theObject.options[0].innerText = getLocalizedString('None');
	theObject.options[1].innerText = getLocalizedString('iSync');
	theObject.options[2].innerText = getLocalizedString('Bluetooth File Exchange');
	theObject.options[3].innerText = getLocalizedString('Bluetooth Preferences');
}

function getLocalizedString (key) {
	try {
		var ret = localizedStrings[key];
		if (ret === undefined) ret = key;
		return ret;
	} catch (ex) { }
	return key;
}

function doKeyDown (event) {
	theKeyDown = String.fromCharCode(event.which);
	if (theKeyDown == "o" || theKeyDown == "O") launchApp();
}
function doKeyUp (event) {
	theKeyDown = false;
}

function updateStatus ( ) {
	if (window.widget) {
	
		glowOn();
		blueStatus = widget.system("/usr/bin/defaults read com.apple.Bluetooth ControllerPowerState",null).outputString;
		if (blueStatus == 1) {
			document.getElementById("icon").src = "Default.png";
		} else document.getElementById("icon").src = "Off.png";
		glowOff();

		return blueStatus;
	
	} else {
		document.getElementById("icon").src = "Off.png";
		return 0;
	}
}

function toggleBluetooth ( ) {
	if (theKeyDown == "o" || theKeyDown == "O") {
		launchApp();
	} else if (window.widget && !switchBusy) {
		switchBusy = true;
		glowOn();
		mouseexit();
		theResult = widget.system("/usr/bin/osascript BluetoothCheck.scpt",null).outputString;
		if (theResult == 1) {
			theResult = widget.system("/usr/bin/osascript BluetoothSwitch.scpt",null).outputString;
			if (theResult == 1) {
				switchFinished(1);
			} else if (theResult == 0) {
				doError('switch');
				switchFinished(0);
				widget.openApplication("com.apple.SystemPreferences");
			} else {
				doError('check');
				switchFinished(0);
				widget.openApplication("com.apple.SystemPreferences");
			}
		} else {
			doError('check');
			switchFinished(0);
			widget.openApplication("com.apple.SystemPreferences");
		}
	}
}

function doError ( theError ) {
	var stringsPath = getLocalizedString('en.lproj');
	widget.system("/usr/bin/osascript BluetoothError.scpt "+theError+
		" "+stringsPath,doNothing).onreadoutput = doNothing;
}

function switchFinished ( theResult ) {
	blueStatus = updateStatus();
	switchBusy = false;
	glowOff();
	if (theResult == 1) {
		if (blueStatus == 1) {
			launchApp();
		} else widget.system("/usr/bin/osascript -e 'tell application \"System Preferences\" to quit'",null);
	}
}

function doNothing ( theArgs ) { }

function launchApp ( ) {
	if (openafter.value == "1") {
		widget.openApplication("com.apple.iSync");
	} else if (openafter.value == "2") {
		widget.openApplication("com.apple.BluetoothFileExchange");
	} else if (openafter.value == "3") {
		widget.openApplication("com.apple.SystemPreferences");
		widget.system("/usr/bin/osascript -e 'tell application \"System Preferences\" to set current pane to pane \"Bluetooth\"'",null);
	}
}

// hide and show preferences

function showPrefs () {

	if (window.widget) widget.prepareForTransition("ToBack"); // freeze the widget
	document.getElementById("front").style.display="none"; // hide the front
	document.getElementById("back").style.display="block"; // show the back
	if (window.widget) setTimeout ("widget.performTransition();", 0); // flip the widget over	
	document.getElementById("fliprollie").style.display = "none"; // hide the circle behind the info button

}

function hidePrefs() {

	// save preferences
	if (window.widget) widget.setPreferenceForKey(openafter.value,widget.identifier+"openafter");

	if (window.widget) widget.prepareForTransition("ToFront"); // freeze the widget
	document.getElementById("back").style.display="none"; // hide the back
	document.getElementById("front").style.display="block"; // show the front
	if (window.widget) setTimeout ("widget.performTransition();", 0); // flip back

}

// preference button animation

var flipShown = false; // a flag used to signify if the flipper is currently shown or not.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event) {
	if (!flipShown) { // if the preferences flipper is not already showing...
		if (animation.timer != null) { // reset the animation timer value, in case a value was left behind
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		var starttime = (new Date).getTime() - 13; 					// set it back one frame
		animation.duration = 500;									// animation time, in ms
		animation.starttime = starttime;							// specify the start time
		animation.firstElement = document.getElementById ("flip");	// specify the element to fade
		animation.timer = setInterval ("animate();", 13);			// set the animation function
		animation.from = animation.now;								// beginning opacity
		animation.to = 1.0;											// final opacity
		animate();													// begin animation
		flipShown = true;											// mark the flipper as animated
	}
}

function mouseexit (event) {
	if (flipShown) {
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ("flip");
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	T = limit_3(time-animation.starttime, 0, animation.duration);	
	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	} else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c) {
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}
function enterflip(event) {
	document.getElementById("fliprollie").style.display = "block";
}
function exitflip(event) {
	document.getElementById("fliprollie").style.display = "none";
}

// glow animtation

var glowShown = false; // a flag used to signify if the glow is currently shown or not.
var glowAnimation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function glowOn () {
	if (!glowShown) { // if the glow is not already showing...
		if (glowAnimation.timer != null) { // reset the animation timer value, in case a value was left behind
			clearInterval (glowAnimation.timer);
			glowAnimation.timer  = null;
		}
		var starttime = (new Date).getTime() - 13; 						// set it back one frame
		glowAnimation.duration = 500;									// animation time, in ms
		glowAnimation.starttime = starttime;							// specify the start time
		glowAnimation.firstElement = document.getElementById ("glow");	// specify the element to fade
		glowAnimation.timer = setInterval ("animateGlow();", 13);		// set the animation function
		glowAnimation.from = glowAnimation.now;							// beginning opacity
		glowAnimation.to = 1.0;											// final opacity
		animateGlow();													// begin animation
		glowShown = true;												// mark the glow as animated
	}
}

function glowOff () {
	if (glowShown && !switchBusy) {
		if (glowAnimation.timer != null) {
			clearInterval (glowAnimation.timer);
			glowAnimation.timer  = null;
		}
		var starttime = (new Date).getTime() - 13;
		glowAnimation.duration = 500;
		glowAnimation.starttime = starttime;
		glowAnimation.firstElement = document.getElementById ("glow");
		glowAnimation.timer = setInterval ("animateGlow();", 13);
		glowAnimation.from = glowAnimation.now;
		glowAnimation.to = 0.0;
		animateGlow();
		glowShown = false;
	}
}

function animateGlow() {
	var T;
	var ease;
	var time = (new Date).getTime();
	T = limit_3(time-glowAnimation.starttime, 0, glowAnimation.duration);	
	if (T >= glowAnimation.duration) {
		clearInterval (glowAnimation.timer);
		glowAnimation.timer = null;
		glowAnimation.now = glowAnimation.to;
	} else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / glowAnimation.duration));
		glowAnimation.now = computeNextFloat (glowAnimation.from, glowAnimation.to, ease);
	}
	glowAnimation.firstElement.style.opacity = glowAnimation.now;
}